#SkIndigo Ruby code is copyright Dale Martens 2009, all rights reserved.

class SkIndigoSunTool

def initialize
    @ip1 = nil
	plugins=Sketchup.find_support_file("Plugins\/skindigo")
	cursor_path=File.join(plugins,"sun.gif")
	@@cursor_id=UI.create_cursor(cursor_path,16,16)
	UI.set_cursor(@@cursor_id)
        
end

def activate
    @ip1 = Sketchup::InputPoint.new
    @ip = Sketchup::InputPoint.new
	
    self.reset(nil)
end

def onSetCursor()
	#p "setting cursor"
	#p @@cursor_id
	cursor = UI.set_cursor(@@cursor_id)
end

def deactivate(view)
    view.invalidate 
end

def onMouseMove(flags, x, y, view)
     @x=x
	 @y=y   
	@ip.pick view, x, y
        if( @ip != @ip1 )
           
            
            @ip1.copy! @ip
                        
            view.tooltip = @ip1.tooltip
        end
	
	view.invalidate
	

end

def onLButtonDown(flags, x, y, view)
    	
        @ip1.pick view, x, y
        if( @ip1.valid? )
            	model=Sketchup.active_model
		cam=view.camera
		box=model.bounds  #get the bounding box of the model
		box.add(cam.eye)
		eye_vec=cam.eye-[0,0,0]
		radii=[]
		8.times {|i|
			rad=(box.corner(i)-[0,0,0]).length.to_f  #calculate the distance from the bounding box corner to the origin
			radii.push(rad)
		}
		max_radius=radii.max
		ray=view.pickray(x,y)
		vec=ray[1]
		point=ray[0]
		vec.length=max_radius*10.0
		sun_dir=vec+eye_vec		
		irs=IndigoRenderSettings.new
		irs.sun_dir=sun_dir
		UI.messagebox ("New Sun Direction set to #{sun_dir}")
		                    
        end
    
    view.lock_inference
    Sketchup.active_model.select_tool nil
end


def draw(view)
    if( @ip1.valid? )
        if( @ip1.display? )
            @ip1.draw(view)
	   
        end
	 
    end
	view.drawing_color="black"
	#screen_coords=view.screen_coords(@ip1.position)
	if @x!=nil and @y!=nil
		#draw_2d_circle(@x,@y,view,10)
		#draw_sun_rays(@x,@y,view,10,10)
		#replaced openGL sun with icon
        @drawn = true
	end
end

#######
def draw_2d_circle(x,y,view,radius,divisions=24)

normal=[0,0,1]
circle_points=[]
cent=[x,y,0]
angle=(360.0/divisions.to_f).degrees
p1=[x+radius,y,0]
circle_points.push(p1)  #add the first circle point to the array
rot_trans=Geom::Transformation.rotation(cent, normal,  angle)
divisions.times {|i|
	last_pt=circle_points.last
	circle_points.push(last_pt.transform(rot_trans))
}

view.draw2d(GL_LINE_LOOP,circle_points)

end

#######
def draw_sun_rays(x,y,view,radius,num_rays)

ray_length=10
ray_offset=2
normal=[0,0,1]
cent=[x,y,0]
angle=(360.0/num_rays.to_f).degrees
p1=[x+radius+ray_offset,y,0]
p2=[x+radius+ray_offset+ray_length,y,0]
rot_trans=Geom::Transformation.rotation(cent, normal,  angle)
num_rays.times {|i|
	view.draw2d(GL_LINES,[p1,p2])
	p1.transform!(rot_trans)
	p2.transform!(rot_trans)
}



end

###
def getExtents()

box=Sketchup.active_model.bounds
if @ip!=nil and @ip.valid?
	box.add(@ip.position)
end
return box

end


def onCancel(flag, view)
    self.reset(view)
end


# Reset the tool back to its initial state
def reset(view)
       
    Sketchup::set_status_text("Select Sun Position", SB_PROMPT)
    @ip1.clear
        
    if( view )
        view.tooltip = nil
        view.invalidate 
    end
  
end

end # class 


